/** Simple styling of slide manager */

body {
  font-family: 'Lato', sans-serif;
  background: #aaaaaa;
  margin: 0;
  padding: 0;
}

*, *::before, *::after {
  box-sizing: border-box;
}

h1, h2, h3, h4, h5, h6 {
  margin: 0;
  padding:0;
}

/*
 * Yellow(in) #ffd700
 * Purple(out) #da70d6
 * Blue(primary) #007bff
 *
 * Light blue(hover) #99ccff;
 */

/* The whole page */
.contents {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding-bottom: 50px;
}

/* Top nav bar, with major page links */
.nav ul {
  list-style: none;
  background-color: #444;
  text-align: center;
  padding: 0;
  margin: 0;
}

.nav li {
  font-size: 1.2em;
  line-height: 40px;
  height: 40px;
  border-bottom: 1px solid #888;
}

.nav a {
  text-decoration: none;
  color: #fff;
  display: block;
  transition: background-color 0.5s;
  padding: 0 1em;
}

.nav a:hover {
  background-color: #005f5f;
}

.nav a.active {
  background-color: #fff;
  color: #444;
  cursor: default;
}

@media screen and (min-width: 600px) {
  .nav li {
    border-bottom: none;
    height: 50px;
    line-height: 50px;
    font-size: 1.4em;
  }

  .nav li {
    display: inline-block;
  }
}

/* Secondary nav with list of pills */
.sub-nav ul {
  list-style: none;
  text-align: center;
  padding: 1em;
  margin: 0;
}

.sub-nav li {
  display: inline-block;
  font-size: 1.1em;
  line-height: 2.2em;
}

.sub-nav a {
  text-decoration: none;
  transition: background-color 0.5s;
  padding: 0.4em 0.8em;
  margin: 0 0.5em;
  border: 1px solid grey;
  border-radius: 1em;
  color: black;
}

.sub-nav a:hover {
  background: #718dff;
  border: 1px solid #718dff;
}

.sub-nav a.active {
  background: #9c28ff;
  border: 1px solid #9c28ff;
  color: #ddd;
}

.sub-nav .btn, .sub-nav .btn:hover {
  display: inline;
  border: 0;
  font-size: 0.9em;
  color: white;
}

.sub-nav .nav-title {
  font-weight: bold;
  padding-right: 1em;
}

/* mirror of user_info for a floating link */
.floating-nav {
  background: #dddddd;
  padding: 0.3rem 1.0rem 0.3rem 0.5rem;
  border-radius: 0 0 1.0rem 0;
  text-decoration: none;
  font-weight: bold;
  left: 0;
  position: absolute;
  transition: 250ms;
  color: black;
}

.floating-nav:hover {
  background: #99ccff;
}

/* list of members of an object */
ul.member-list {
  list-style: none;
  text-align: center;
  padding: 0;
  margin: 0;
}

.member-list li {
  transition: background-color 0.5s;
  padding: 0 0.5em;
  margin-bottom: 0.1em;
  border: 1px solid grey;
  border-radius: 1em;
  display: flex;
  align-items: center;
  justify-content: space-between;
}

.member-list li:hover {
  background: rgba(255, 255, 255, 0.3);
}

.member-list a {
  text-decoration: none;
  color: black;
  padding-right: 0.5em;
}

.member-list li button {
  background: none;
  color: rgba(0, 0, 0, 0.54);
  border: 0;
  border-radius: 100%;
  padding: 0;
}

.member-list li button:hover {
  background: rgba(255, 255, 255, 0.4);
  color: black;
}

.inline-member-list {
  display: inline-flex;
  flex-flow: wrap;
}

/* table-ish views
 *
 */
.table {
  border-collapse: collapse;
  border-spacing: 0;
}

.table td, .table th {
  border: 1px solid transparent;
  height: 30px;
  transition: all 0.3s;
  padding: 0 0.5em;
}

.table th {
  background: #bfbfbf;  /* Darken header a bit */
  font-weight: bold;
}

.table tr:nth-child(even) {
  background: #f3f3f3;
}

.table tr:nth-child(odd) {
  background: #fafafa;
}

.table tr:hover {
  background: #9c9c9c
}

.table td:hover {
  background: #606060;
  color: #ffffff;
}

/* Hover cell effect! */
/*
 * Slide or panel view
 */
fieldset {
  border: 2px solid grey;
}

fieldset legend {
  font-size: large;
  font-weight: bold;
  padding: 0.2rem;
}

/* General form styling; try and keep a tight consistent look
 * across different browsers so will need to override a lot
 * of built in form stylesheets.
 */
button, .btn, .btn-active {
  display: inline-block;
  border: 2px solid transparent;
  border-radius: 0.5em;
  padding: 0.1em 0.3em;
  margin: 0.1em;
  text-decoration: none;
  background: none #007bff;
  color: #ffffff;
  font-weight: bold;
  white-space: nowrap;
  cursor: pointer;
  text-align: center;
  transition: background 250ms ease-in-out, transform 50ms ease;
  -webkit-appearance: none;
  -moz-appearance: none;
}

button:hover, .btn:hover, .btn-active:hover,
button:focus, .btn:focus, .btn-active:focus {
  background: #0053ba;
}

button:focus, .btn:focus, .btn-active:focus {
  border: 2px solid #fff;
}

button:active, .btn:active, .btn-active:active {
  transform: scale(0.95);
}

button[disabled], fieldset[disabled] button,
button[disabled]:hover, fieldset[disabled] button:hover,
.btn[disabled], fieldset[disabled] .btn,
.btn[disabled]:hover, fieldset[disabled] .btn:hover,
.btn-active[disabled] {
  background-color: #bbbbbb;
  cursor: default;
}

button, input, select, textarea {
  font-family: inherit;
  font-size: 100%;
}

input[type=text], input:not([type]), input[type=date], input[type=time],
input[type=number], select {
  border: 0 solid transparent;
  border-bottom: 2px solid grey;
  padding: 0.1em;
  background: #fff;
}

input[type=checkbox] {
  -webkit-appearance: none;
  -moz-appearance: none;
}

/* Edge will not add pseudo elements to checkboxes. */
/* Keep browser tick and remove border instead */
input[type=checkbox]::-ms-check {
  border: none;
}

input[type=checkbox] {
  position: relative;
  width: 1em;
  height: 1em;
  border: 2px solid gray;
  /* Adjusts the position of the checkboxes on the text baseline */
  vertical-align: -5px;
  /* Set here so that Windows' High-Contrast Mode can override */
  color: black;
  background: white;
}

input[type=checkbox]::before {
  content: "✘";
  position: absolute;
  font-size: 1.3em;
  right: -0.1em;
  top: -0.3em;
  visibility: hidden;
}

input[type=checkbox]:checked::before {
  /* Use `visibility` instead of `display` to avoid recalculating layout */
  visibility: visible;
}

input[type=checkbox]:disabled {
  border-color: black;
  background: #ddd;
  color: gray;
}

textarea {
  border: 2px solid grey;
  padding: 0.1em;
  background: #fff;
}

fieldset[disabled] input, input[disabled],
fieldset[disabled] textarea, textarea[disabled],
fieldset[disabled] select, select[disabled] {
  background: none;
}

input[type=color] {
  border: none;
  border-radius: 0.5em;
  padding: 0 0.5em;
  background: none;
  cursor: pointer;
  transition: background 250ms ease-in-out,
  transform 150ms ease;
  -webkit-appearance: none;
  -moz-appearance: none;
}

input[type=color][disabled], fieldset[disabled] input[type=color] {
  cursor: default;
}


/* More specific element styling */
.slide-row {
  display: flex;
  margin: 1rem auto;
  flex-flow: wrap;
  justify-content: center;
}

.slide-preview {
  width: 384px;
  height: 216px;
  background: #eee8 url('data:image/svg+xml, <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill-opacity=".10" ><rect x="10" width="10" height="10" /><rect y="10" width="10" height="10" /></svg>');
  background-size: 20px 20px;
  padding: 0;
  position: relative;
  border: solid 2px grey;
  overflow: hidden;
}

.loading {
  background: #eee8 url('data:image/svg+xml, <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill-opacity=".50" ><rect x="10" width="10" height="10" /><rect y="10" width="10" height="10" /></svg>') !important;
  background-size: 20px 20px;
  filter: none !important;
}

.loading:after {
  content: "";
  background: #eee8 url('data:image/svg+xml, <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill-opacity=".50" ><rect width="10" height="10" /><rect x="10" y="10" width="10" height="10" /></svg>');
  background-size: 20px 20px;
  opacity: 0;
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  z-index: 2;
  animation-name: loading-breathe;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  animation-timing-function: ease-in-out;
}

@keyframes loading-breathe {
  0% {
    opacity: 0;
  }
  50% {
    opacity: 1;
  }
  100% {
    opacity: 0;
  }
}

.slide-view {
  max-width: 412px;
  margin: 0.5rem;
}

.display-view {
  max-width: 300px;
  margin: 0.5rem;
}

.slide-preview-image {
  width: 384px;
  height: 216px;
  object-fit: cover;
  position: absolute;
  background-position: center;
}

.slide-text-container, .slide-calendar-container {
  text-align: center;
  display: flex;
  flex-direction: column;
  flex-wrap: wrap;
  align-items: center;
  position: absolute;
  justify-content: space-between;
  height: 90%;
  padding-top: 4%;
}

.rule-members, .rule-parameters, .rule-displays {
  min-width: 238px;
  padding-left: 0.5rem;
  padding-right: 0.5rem;
}

.rule-parameters {
  min-width: 400px;
}

.active-day {
  margin-right: 0.5em;
  opacity: 20%;
}

.active-day.active {
  opacity: 100%;
}

/* QR code */
.content-url {
  position: absolute;
  visibility: hidden;
  right: 0.2rem;
  bottom: 0.2rem;
}

.content-url:not(:empty):after {
  display: block;
  visibility: visible;
  position: absolute;
  right: 0.2rem;
  bottom: 0.2rem;
  content: " ";
  background-image: url("/image/qr");
  background-size: 2rem 2rem;
  height: 2rem;
  width: 2rem;
}

/* Text layout slide preview */
.slide-text {
  color: white;
  text-shadow: 0 1px 1px black;
  background: grey;
  box-shadow: 0 2px 2px black;
  padding: 0.2rem 0.5rem;
}

.slide-text:empty {
  padding: 0;
  margin: 1rem;
}

h2.slide-text {
  font-size: 1.2rem;
  margin: 0;
}

p.slide-text {
  font-size: 0.8rem;
  margin: 0 4%;
}

/* Calendar layout slide preview */
.slide-calendar-container {
  justify-content: flex-start;
  width: 100%;
}

.calendar-header {
  position: absolute;
  padding-left: 3%;
  font-size: 80%;
  font-weight: bold;
  max-width: 90%;
}

.calendar-item {
  width: 46%;
  max-height: 2.6em;
  overflow: hidden;
  margin: 0.09em;
}

.calendar-time {
  display: table-cell;
  min-width: 2em;
  font-size: 0.7em;
  text-align: center;
}

.calendar-summary {
  display: table-cell;
  font-size: 0.54em;
  vertical-align: top;
  padding: 0.2em;
}

/* Room bookings view */
.slide-bookings-container {
  position: absolute;
  width: 100%;
  height: 90%;
  padding-top: 4%;
  display: table;
}

.bookings-title {
  position: absolute;
  top: 0;
  margin: 0;
}

.slide-bookings-column {
  display: table-cell;
  width: 50%;
  overflow: hidden;
}

.slide-bookings-column-left {
  vertical-align: middle;
}

.bookings-header {
  text-align: center;
  font-weight: bold;
  margin-top: 5%;
  margin-bottom: 5%;
}

.bookings-item {
  width: 90%;
  margin: 0.1em auto;
}

.slide-bookings-current {
  text-align: center;
}

.slide-bookings-remaining {
  text-align: center;
  font-size: 70%;
}

.slide-bookings-progress {
  width: 100%;
  height: 20px;
}

.slide-bookings-progress-complete {
  width: 35%;
  height: 100%
}


fieldset label {
  margin-right: 1em;
}

textarea {
  width: 10em;
  height: 2.5em;
  transition: 1s;
  margin: 0;
  z-index: 0;
}

textarea:focus, textarea:hover {
  width: 22em;
  transition: 0.5s;
  height: 10.5em;
  margin: -4em -6em;
  z-index: 20;
}

.range-value {
  min-width: 3em;
  text-align: right;
}

.bg-pattern-colour-btn {
  text-shadow: 0 0 2px #000000, 0 0 1px #000000;
  padding: 0.1em;
  border-radius: 0.2em;
  border: 1px solid transparent;
}

.bg-pattern-colour-btn:hover {
  background-color: #aaa;
  border: 1px solid grey;
}


input[type=number][size="2"] {
  width: 3em;
}

input[type=range] {
  width: 9em;
}

/* Changing background destroys browser styling, just change text */
.soon > input {
  color: #660022;
}

.past > input {
  color: #dd0000;
}

label[title] {
  cursor: help;
}

label.checkbox {
  margin: 0;
  padding: 0;
}

.form-row {
  display: flex;
  justify-content: space-between;
  vertical-align: text-top;
  padding: 0.2rem;
}

form.changed fieldset {
  background: #da70d644;
  border-color: black;
}

form.changed .save-button {
  color: black;
  background-color: #ffd700;
}

.drag-over {
  background: #ffd700 !important;
}

.long-description {
  max-height: 3.6em;
  overflow: hidden;
  transition: 1s;
  max-width: 380px;
}

.long-description:hover {
  max-height: 99em;
}

/* Live Preview */
.modal-dismiss {
  position: fixed;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  background: rgba(128, 128, 128, 0.5);
  justify-content: center;
  align-items: center;
  display: flex;
}

.changed a.popup-link {
  color: #606060;
  background: #bbbbbb;
  position: relative;
}

.changed a.popup-link:hover:after {
  content: "Save slide to update preview";
  bottom: 1rem;
  left: 3rem;
  right: -7rem;
  position: absolute;
  background: #eeeeee;
  color: black;
  padding: 0.2em;
  font-weight: normal;
  border-radius: 0.2em;
  text-align: center;
  opacity: 0.9;
  white-space: normal;
}

/* Image management UI */
.overlay-content {
  max-height: 90%;
  overflow: auto;
  background: #eee;
  padding: 3rem 2rem;
  position: relative;
  border: 4px solid black;
  min-width: 300px;
}

.asset-library {
  max-width: 960px;
  margin-bottom: 3rem;
}

.close {
  position: absolute;
  right: 1em;
  top: 1em;
}

.asset-library .image-attributes {
  border-collapse: collapse;
}

.asset-library .attribute-value {
  min-width: 10em;
}

.asset-library .image-attributes td {
  padding: 0.1em 0.5em;
}

.asset-library td[contenteditable] {
  background: #fff;
  box-shadow: inset 0 -2px 0 0 #444;
}

.asset-library .tag-link, .dismiss {
  cursor: pointer;
  color: #007bff;
  font-weight: bold;
}

.asset-library .tag-link:hover, .dismiss {
  color: #0053ba;
}

/* User management UI */
#user-info {
  background: #dddddd;
  padding: 0.3rem 0.5rem 0.3rem 1.0rem;
  border-radius: 0 0 0 1.0rem;
  text-decoration: none;
  font-weight: bold;
  right: 0;
  position: absolute;
  transition: 250ms;
  color: black;
}

#user-info:hover {
  background: #99ccff;
}

/* Room booking form */
.slide-bookings-fields[data-booking-type=booker] .not-booker {
  display: none;
}

.slide-bookings-fields[data-booking-type=mrbs] .not-mrbs {
  display: none;
}

/* Web view options */
.slide-web-page-fields.web-live .not-web-live {
  display: none;
}

/* Utility classes */
.d-none {
  display: none !important;
}

.ml-1 {
  margin-left: 0.25rem
}

.ml-3 {
  margin-left: 1rem;
}

.mr-1 {
  margin-right: 0.25rem;
}

.mr-3 {
  margin-right: 1rem;
}

.mb-1 {
  margin-bottom: 0.25rem;
}

.mb-3 {
  margin-bottom: 1rem;
}

.mt-1 {
  margin-top: 0.25rem;
}

.mt-3 {
  margin-top: 1rem;
}

/* hides admin-only elements */
body:not(.admin) .admin-only {
  display: none !important;
}

.material-icons {
  vertical-align: middle;
}

.material-icons.md-inline {
  font-size: 100%;
}

.text-left {
  text-align: left;
}

.text-center {
  text-align: center;
}

.text-right {
  text-align: right;
}

.bg-white {
  background: white;
}

.no-scroll {
  overflow: hidden;
}

.can-edit {
  font-weight: bold;
}